﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.WindowsMobile.Samples.Location;

namespace GPSInfo
{
    public partial class frmMain : Form
    {

        Gps gpsMain = null;
        public frmMain()
        {
            InitializeComponent();
            gpsMain = new Gps();
        }

        private void menuItemExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void gps_LocationChanged(object sender, LocationChangedEventArgs args)
        {
            MessageHandler cu = UpdateControl;

            GpsPosition position = args.Position;

            if (position.LatitudeValid)
                Invoke(cu, tbLatitude, position.Latitude.ToString());
            if (position.LongitudeValid)
                Invoke(cu, tbLongitude, position.Longitude.ToString());
            if (position.HeadingValid)
                Invoke(cu, tbHeading, position.Heading.ToString());
            if (position.SatellitesInViewCountValid)
                Invoke(cu, tbSatellites, position.SatellitesInViewCount.ToString());
        }

        private void gps_DeviceStateChanged(object sender, DeviceStateChangedEventArgs args)
        {
            MessageHandler cu = UpdateControl;

            GpsDeviceState device = args.DeviceState;

            Invoke(cu, tbGPSDevice, device.FriendlyName);
            Invoke(cu, tbGPSDeviceState, device.DeviceState.ToString());
            Invoke(cu, tbGPSServiceState, device.ServiceState.ToString());
        }

        private delegate void MessageHandler(Control control, string message);

        private void UpdateControl(Control control, string message)
        {
            control.Text = message;
        }


        private void btnStart_Click(object sender, EventArgs e)
        {
            if (!gpsMain.Opened)
            {
                gpsMain.DeviceStateChanged += new DeviceStateChangedEventHandler(gps_DeviceStateChanged);
                gpsMain.LocationChanged += new LocationChangedEventHandler(gps_LocationChanged);
                gpsMain.Open();
            }
            else
            {
                gpsMain.DeviceStateChanged -= gps_DeviceStateChanged;
                gpsMain.LocationChanged -= gps_LocationChanged;
                gpsMain.Close();
                tbGPSDevice.Text = "";
                tbGPSDeviceState.Text = "";
                tbGPSServiceState.Text = "";
                tbHeading.Text = "";
                tbLatitude.Text = "";
                tbLongitude.Text = "";
                tbSatellites.Text = "";
            }
            btnStart.Enabled = gpsMain.Opened ? false : true;
        }

        private void frmMain_Closing(object sender, CancelEventArgs e)
        {
            if (gpsMain.Opened)
            {
                gpsMain.DeviceStateChanged -= gps_DeviceStateChanged;
                gpsMain.LocationChanged -= gps_LocationChanged;
                gpsMain.Close();
            }
        }

    }
}